// ClientDlg.cpp : implementation file
//

#include "stdafx.h"
#include <string>

#include "Client.h"
#include "ClientDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

const int ID_TIMER1 = 100;

using namespace std;

/////////////////////////////////////////////////////////////////////////////
// CClientDlg dialog

CClientDlg::CClientDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CClientDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CClientDlg)
	m_Address = _T("");
	m_PortStr = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CClientDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CClientDlg)
	DDX_Control(pDX, IDC_COMBO3, m_Protocol);
	DDX_Control(pDX, IDC_COMBO2, m_Device);
	DDX_Control(pDX, IDC_COMBO1, m_Mode);
	DDX_Control(pDX, IDC_BUTTON3, m_Stop);
	DDX_Control(pDX, IDC_BUTTON1, m_StartSpeaker);
	DDX_Text(pDX, IDC_EDIT1, m_Address);
	DDX_Text(pDX, IDC_EDIT3, m_PortStr);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CClientDlg, CDialog)
	//{{AFX_MSG_MAP(CClientDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_CLOSE()
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON3, OnButton3)
	ON_CBN_CLOSEUP(IDC_COMBO1, OnCloseupCombo1)
	ON_BN_CLICKED(IDC_BUTTON4, OnButton4)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CClientDlg message handlers

BOOL CClientDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

	m_Address = "192.168.1.1";
	m_PortStr = "17860";
	UpdateData(FALSE);

	VCInit();

	for (int i = 0; i < m_WaveIn->GetDeviceCount(); i++)
		m_Device.AddString(m_WaveIn->GetDeviceName(i));

	m_Device.SetCurSel(0);
	m_Mode.SetCurSel(0);
	m_Protocol.SetCurSel(1);

	SetTimer(ID_TIMER1, 500, NULL);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CClientDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CClientDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CClientDlg::VCInit()
{
	m_Gate.CreateInstanceLic(__uuidof(vcproMediaGateX), L"0");
	m_WaveIn.CreateInstanceLic(__uuidof(vcproWaveInDeviceX), L"0");

	m_Gate->PcmSamplesPerSec = 22050;
}

void CClientDlg::VCUninit() { m_Gate->Disconnect(); }

void CClientDlg::OnClose() 
{
	KillTimer(ID_TIMER1);
	VCUninit();
	CDialog::OnClose();
}

void CClientDlg::OnTimer(UINT nIDEvent) 
{
	int active = m_Gate->IsClientActive;
   m_StartSpeaker.EnableWindow(!active);
   m_Stop.EnableWindow(active);

	CWnd* pWnd;

	char buffer[10];
	itoa(m_Gate->BytesReceived, buffer, 10);
	string sizeIn(string("bytes received: ") + string(buffer));
	itoa(m_Gate->BytesSent, buffer, 10);
	string sizeOut(string("bytes sent: ") + string(buffer));

	pWnd = GetDlgItem(IDC_STATIC1);
	pWnd->SetWindowText(sizeIn.c_str());
	pWnd = GetDlgItem(IDC_STATIC2);
	pWnd->SetWindowText(sizeOut.c_str());

	CDialog::OnTimer(nIDEvent);
}

void CClientDlg::OnButton1() 
{
	UpdateData();

   m_Gate->Active = false;
   m_Gate->EnableRecording = m_Mode.GetCurSel() == 0;
   m_Gate->EnablePlayback = m_Mode.GetCurSel() == 1;
	m_Gate->DeviceId = m_Device.GetCurSel();
	m_Gate->Proto = static_cast<unaProtoType>(m_Protocol.GetCurSel());

	BSTR port = m_PortStr.AllocSysString();
   m_Gate->Port = port;
	SysFreeString(port);

	BSTR host = m_Address.AllocSysString();
	m_Gate->Connect(host);
	SysFreeString(host);
}

void CClientDlg::OnButton3()
{
	m_Gate->Disconnect();
}

void CClientDlg::OnCloseupCombo1() 
{
	m_PortStr = m_Mode.GetCurSel() == 0 ? "17860" : "17861";
	UpdateData(FALSE);
}

void CClientDlg::OnButton4() 
{
	char buffer[5];
	itoa(m_Device.GetCurSel(), buffer, 10);
	string params = "/p /d" + string(buffer);
	ShellExecute(NULL, "open", "sndvol32", params.c_str(), NULL, SW_SHOW);
}
